using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace DownloadCE6R3
{
    public partial class MainForm : Form
    {
        private int index = 0;
        //private List<string> files = new List<string> (new string[] {"Windows Embedded CE 6.0 R3.msi", "Help.cab"});
        private string[] files = new string[] { "Windows Embedded CE 6.0 R3.msi", "Help.cab", "FP.cab", "wcetk_1.cab", "CE_1_1.cab", "CE_2_1.cab", "CE_3_lc_1.cab", "CE_3_1.cab", "CE_3_2.cab", "CE_3_3.cab", "CE_3_4.cab", "CE_3_5.cab", "CE_3_6.cab", "CE_3_7.cab", "CE_3_8.cab", "CE_3_9.cab", "CE_3_10.cab", "CE_4_1.cab", "CE_4_2.cab", "CE_4_3.cab", "CE_4_4.cab", "CE_4_5.cab", "CE_4_6.cab", "CE_4_7.cab", "CE_4_8.cab", "CE_4_9.cab", "CE_4_10.cab", "CE_4_11.cab", "CE_5_lc_1.cab", "CE_5_1.cab", "CE_5_2.cab", "CE_5_3.cab", "CE_5_4.cab", "CE_5_5.cab", "CE_5_6.cab", "CE_5_7.cab", "CE_5_8.cab", "CE_5_9.cab", "CE_6_1.cab", "CE_6_2.cab", "CE_6_3.cab", "CE_6_4.cab", "CE_6_5.cab", "CE_6_6.cab", "CE_6_7.cab", "CE_6_8.cab", "CE_6_9.cab", "CE_6_10.cab", "CE_6_11.cab", "CE_7_lc_1.cab", "CE_7_1.cab", "CE_7_2.cab", "CE_7_3.cab", "CE_7_4.cab", "CE_7_5.cab", "CE_7_6.cab", "CE_7_7.cab", "CE_7_8.cab", "CE_7_9.cab", "CE_7_10.cab", "CE_8_1.cab", "CE_8_2.cab", "CE_8_3.cab", "CE_8_4.cab", "CE_8_5.cab", "CE_8_6.cab", "CE_8_7.cab", "CE_8_8.cab", "CE_8_9.cab", "CE_8_10.cab", "CE_8_11.cab", "CE_9_lc_1.cab", "CE_9_1.cab", "CE_9_2.cab", "CE_9_3.cab", "CE_9_4.cab", "CE_9_5.cab", "CE_9_6.cab", "CE_9_7.cab", "CE_9_8.cab", "CE_9_9.cab", "CE_9_10.cab", "CE_10_1.cab", "CE_10_2.cab", "CE_10_3.cab", "CE_10_4.cab", "CE_10_5.cab", "CE_10_6.cab", "CE_10_7.cab", "CE_10_8.cab", "CE_10_9.cab", "CE_10_10.cab", "CE_10_11.cab", "CE_11_lc_1.cab", "CE_11_1.cab", "CE_11_2.cab", "CE_11_3.cab", "CE_11_4.cab", "CE_11_5.cab", "CE_11_6.cab", "CE_11_7.cab", "CE_11_8.cab", "CE_11_9.cab", "CE_11_10.cab", "CE_12_1.cab", "CE_12_2.cab", "CE_12_3.cab", "CE_12_4.cab", "CE_12_5.cab", "CE_12_6.cab", "CE_12_7.cab", "CE_12_8.cab", "CE_12_9.cab", "CE_12_10.cab", "CE_12_11.cab", "CE_13_lc_1.cab", "CE_13_1.cab", "CE_13_2.cab", "CE_13_3.cab", "CE_13_4.cab", "CE_13_5.cab", "CE_13_6.cab", "CE_13_7.cab", "CE_13_8.cab", "CE_13_9.cab", "CE_13_10.cab", "CE_14_1.cab", "CE_14_2.cab", "CE_14_3.cab", "CE_14_4.cab", "CE_14_5.cab", "CE_14_6.cab", "CE_14_7.cab", "CE_14_8.cab", "CE_14_9.cab", "CE_14_10.cab", "CE_14_11.cab", "CE_15_lc_1.cab", "CE_15_1.cab", "CE_15_2.cab", "CE_15_3.cab", "CE_15_4.cab", "CE_15_5.cab", "CE_15_6.cab", "CE_15_7.cab", "CE_15_8.cab", "CE_15_9.cab", "CE_15_10.cab", "CE_16_1.cab", "CE_16_2.cab", "CE_16_3.cab", "CE_16_4.cab", "CE_16_5.cab", "CE_16_6.cab", "CE_16_7.cab", "CE_16_8.cab", "CE_16_9.cab", "CE_16_10.cab", "CE_16_11.cab" };
        private WebClient web;
        private string downloadPath;
        private const string downloadUrl = "http://download.microsoft.com/download/F/5/2/F5296720-250A-4055-991C-0CEA5DE11436/";

        private string FileName
        {
            get { return files[index]; }
        }

        private string FullPath
        {
            get { return downloadPath + files[index]; }
        }

        private Uri FullUrl
        {
            get { return new Uri(downloadUrl + files[index]); }
        }

        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            // I used this to find out all the names of the cabs
            /*
            for (int x = 1; x < 20; x++)
                for (int y = 1; y < 20; y++)
                    files.Add(string.Format("CE_{0}_{1}.cab", x, y));
            */

            web = new WebClient();
            web.DownloadFileCompleted += new AsyncCompletedEventHandler(web_DownloadFileCompleted);
            web.DownloadProgressChanged += new DownloadProgressChangedEventHandler(web_DownloadProgressChanged);

            // Ask user where to download to...
            if (folderBrowserDialog.ShowDialog(this) == DialogResult.OK)
            {
                downloadPath = folderBrowserDialog.SelectedPath + "\\";
                while (!DownloadFile()) index++;
            }
            else
                this.Close();
        }

        private bool DownloadFile()
        {
            if (index >= /*files.Count*/ files.Length)
            {
                txtLog.AppendText("\r\n");
                txtLog.AppendText("Done!");
                return true;
            }
            
            if (File.Exists(FullPath))
            {
                txtLog.AppendText(string.Format("File \"{0}\" already exists, skipping\r\n", FileName));
                return false;
            }
            
            txtLog.AppendText(string.Format("Downloading \"{0}\":   0%", FileName));
            web.DownloadFileAsync(FullUrl, FullPath);
            return true;
        }

        void web_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            txtLog.SelectionStart = txtLog.Text.Length - 4;
            txtLog.SelectionLength = 4;
            txtLog.SelectedText = string.Format("{0,3:0}%", e.ProgressPercentage);
        }

        void web_DownloadFileCompleted(object sender, AsyncCompletedEventArgs e)
        {
            if (e.Cancelled)
                return;

            if (e.Error != null)
            {
                txtLog.SelectionStart = txtLog.Text.Length - 4;
                txtLog.SelectionLength = 4;
                txtLog.SelectedText = string.Format("Error: {0}", e.Error.Message);
                File.Delete(FullPath);
            }
            txtLog.AppendText("\r\n");
            do
            {
                index++;
            } while (!DownloadFile());
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (web.IsBusy && (MessageBox.Show("Download in progress, are you sure you want to quit?", "Quit", MessageBoxButtons.YesNo) == DialogResult.No))
                e.Cancel = true;
            else
                web.CancelAsync();
        }
    }
}